#include "aes.h"
#include "loader.h"

#if KEY_COUNT > 0

#include "aeskeys.inc"

typedef unsigned char byte;

#define BPOLY			0x1b	//!< (x^8+x^4+x^3+x+1)̉8ޯāA(x^4+x^3+x+1)
#define BLOCKSIZE		16		//!< ޲Đł̉e

#if KEY_COUNT == 1
	#define KEYBITS		128		//!< AES128gp
#elif KEY_COUNT == 2
	#define KEYBITS		192		//!< AES196gp
#elif KEY_COUNT == 3
	#define KEYBITS		256		//!< AES256gp
#else
	#error 1,2M܂3̌gpĂ!
#endif

#if KEYBITS == 128
	#define ROUNDS		10		//!< 
	#define KEYLENGTH	16		//!< ޲Đł̌
#elif KEYBITS == 192
	#define ROUNDS		12		//!< 
	#define KEYLENGTH	24		//!< ޲Đł̌
#elif KEYBITS == 256
	#define ROUNDS		14		//!< 
	#define KEYLENGTH	32		//!< ޲Đł̌
#else
	#error 128,192܂256ޯĂłȂ΂Ȃ܂!
#endif

#define EXPANDED_KEY_SIZE (BLOCKSIZE * (ROUNDS+1))	//!< 176,208܂240޲

byte block1[ 256 ];		//!< Ɨ̈1
byte block2[ 256 ];		//!< Ɨ̈2

byte * powTbl;			//!< wQƕ\̍ŏIgpʒu
byte * logTbl;			//!< ΐQƕ\̍ŏIgpʒu
byte * sBox;			//!< Sޯ̍ŏIgpʒu
byte * sBoxInv;			//!< tSޯ̍ŏIgpʒu
byte * expandedKey;		//!< g̍ŏIgpʒu

void CalcPowLog( byte * powTbl, byte * logTbl )
{
	byte i = 0;
	byte t = 1;

	do {
		// wƑΐ̍Ƃ$03gp
		powTbl[i] = t;
		logTbl[t] = i;
		i++;

		// GF(2^8)t3{
		t ^= (t << 1) ^ (t & 0x80 ? BPOLY : 0);
	} while( t != 1 );			// Ii<255ۏ

	powTbl[255] = powTbl[0];	// 255='-0',254=-1,`
}

void CalcSBox( byte * sBox )
{
	byte i, rot;
	byte temp;
	byte result;

	// sBox[]̑S𖞂
	i = 0;
	do {
		// GF(2^8)ŋt
		if( i > 0 ) {
			temp = powTbl[ 255 - logTbl[i] ];
		} else {
			temp = 0;
		}

		// GF(2)ų̋ݕϊ
		result = temp ^ 0x63;					// GF(2)޸ْǉŊJn
		for( rot = 0; rot < 4; rot++ ) {
			// ]
			temp = (temp<<1) | (temp>>7);

			// GF(2)ŉ]޲Ăɒǉ
			result ^= temp;
		}

		// \Ɍʔzu
		sBox[i] = result;
	} while( ++i != 0 );
}

void CalcSBoxInv( byte * sBox, byte * sBoxInv )
{
	byte i = 0;
	byte j = 0;

	// ipsBoxInv[]̑SvfŜʂČJԂ
	do {
		// jpSBox[]ŜʂČ
		do {
			// ݂j݂i̋t
			if( sBox[ j ] == i ) {
				// Ȃ΁AsBoxInc[]ݒ肵ČI}
				sBoxInv[ i ] = j;
				j = 255;
			}
		} while( ++j != 0 );
	} while( ++i != 0 );
}

void CycleLeft( byte * row )
{
	// z4޲Ă1Ɏ
	byte temp = row[0];
	row[0] = row[1];
	row[1] = row[2];
	row[2] = row[3];
	row[3] = temp;
}

void InvMixColumn( byte * column )
{
	byte result0, result1, result2, result3;
	byte column0, column1, column2, column3;
	byte xor;

	// ͏ȂĂIARCׂ߲łƌIȺނ𐶐܂B
	column0 = column[0];
	column1 = column[1];
	column2 = column[2];
	column3 = column[3];

	// Iv(XORp\vfZ)
	result0 = column1 ^ column2 ^ column3;
	result1 = column0 ^ column2 ^ column3;
	result2 = column0 ^ column1 ^ column3;
	result3 = column0 ^ column1 ^ column2;

	// 2̏]BPOLYōsZ
	// ̑ްeƖ֌WȎ񐔂ۏ؂邽߂Ɉȉ̕@s܂B
	// ̺ނύXɂ͒ӂPĂB
	xor = 0;
	if (column0 & 0x80) {
		xor = BPOLY;
	}
	column0 <<= 1;
	column0  ^= xor;

	xor = 0;
	if (column1 & 0x80) {
		xor = BPOLY;
	}
	column1 <<= 1;
	column1  ^= xor;

	xor = 0;
	if (column2 & 0x80) {
		xor = BPOLY;
	}
	column2 <<= 1;
	column2  ^= xor;

	xor = 0;
	if (column3 & 0x80) {
		xor = BPOLY;
	}
	column3 <<= 1;
	column3  ^= xor;

	// XɕIȍv
	result0 ^= column0 ^ column1;
	result1 ^= column1 ^ column2;
	result2 ^= column2 ^ column3;
	result3 ^= column0 ^ column3;

	// 2̏]BPOLYōsZ
	// ̑ްeƖ֌WȎ񐔂ۏ؂邽߂Ɉȉ̕@s܂B
	// ̺ނύXɂ͒ӂPĂB
	xor = 0;
	if (column0 & 0x80) {
		xor = BPOLY;
	}
	column0 <<= 1;
	column0  ^= xor;

	xor = 0;
	if (column1 & 0x80) {
		xor = BPOLY;
	}
	column1 <<= 1;
	column1  ^= xor;

	xor = 0;
	if (column2 & 0x80) {
		xor = BPOLY;
	}
	column2 <<= 1;
	column2  ^= xor;

	xor = 0;
	if (column3 & 0x80) {
		xor = BPOLY;
	}
	column3 <<= 1;
	column3  ^= xor;

	// XɕIȍv
	result0 ^= column0 ^ column2;
	result1 ^= column1 ^ column3;
	result2 ^= column0 ^ column2;
	result3 ^= column1 ^ column3;

	// 2̏]BPOLYōsZ
	// ̑ްeƖ֌WȎ񐔂ۏ؂邽߂Ɉȉ̕@s܂B
	// ̺ނύXɂ͒ӂPĂB
	xor = 0;
	if (column0 & 0x80) {
		xor = BPOLY;
	}
	column0 <<= 1;
	column0  ^= xor;

	xor = 0;
	if (column1 & 0x80) {
		xor = BPOLY;
	}
	column1 <<= 1;
	column1  ^= xor;

	xor = 0;
	if (column2 & 0x80) {
		xor = BPOLY;
	}
	column2 <<= 1;
	column2  ^= xor;

	xor = 0;
	if (column3 & 0x80) {
		xor = BPOLY;
	}
	column3 <<= 1;
	column3  ^= xor;

	// Ō̕Iȍv
	column0 ^= column1 ^ column2 ^ column3;

	// ̍s޲ēɊi[ꂽŌ̍v
	column[0] = result0 ^ column0;
	column[1] = result1 ^ column0;
	column[2] = result2 ^ column0;
	column[3] = result3 ^ column0;
}

void SubBytes( byte * bytes, byte count )
{
	do {
		*bytes = sBox[ *bytes ];				// ԓőSĂ޲Ău
		bytes++;
	} while( --count );
}

void InvSubBytesAndXOR( byte * bytes, byte * key, byte count )
{
	do {
//		*bytes = sBoxInv[ *bytes ] ^ *key;		// ԓőSĂ޲ĂtuČZ
		*bytes = block2[ *bytes ] ^ *key;		// block2[]ڎgp(x)
		bytes++;
		key++;
	} while( --count );
}

void InvShiftRows( byte * state )
{
	byte temp;

	// :(state[])͗Pʂɐ

	// 2sE1
	temp = state[ 1 + 3*4 ];
	state[ 1 + 3*4 ] = state[ 1 + 2*4 ];
	state[ 1 + 2*4 ] = state[ 1 + 1*4 ];
	state[ 1 + 1*4 ] = state[ 1 + 0*4 ];
	state[ 1 + 0*4 ] = temp;

	// 3sE2
	temp = state[ 2 + 0*4 ];
	state[ 2 + 0*4 ] = state[ 2 + 2*4 ];
	state[ 2 + 2*4 ] = temp;
	temp = state[ 2 + 1*4 ];
	state[ 2 + 1*4 ] = state[ 2 + 3*4 ];
	state[ 2 + 3*4 ] = temp;

	// 4sE3(ƁA1)
	temp = state[ 3 + 0*4 ];
	state[ 3 + 0*4 ] = state[ 3 + 1*4 ];
	state[ 3 + 1*4 ] = state[ 3 + 2*4 ];
	state[ 3 + 2*4 ] = state[ 3 + 3*4 ];
	state[ 3 + 3*4 ] = temp;
}

void InvMixColumns( byte * state )
{
	InvMixColumn( state + 0*4 );
	InvMixColumn( state + 1*4 );
	InvMixColumn( state + 2*4 );
	InvMixColumn( state + 3*4 );
}

void XORBytes( byte * bytes1, byte * bytes2, byte count )
{
	do {
		*bytes1 ^= *bytes2;		// GF(2)ŉZ(ƁAXOR)
		bytes1++;
		bytes2++;
	} while( --count );
}

void CopyBytes( byte * to, byte * from, byte count )
{
	do {
		*to = *from;
		to++;
		from++;
	} while( --count );
}

void KeyExpansion( byte * expandedKey )
{
	byte temp[4];
	byte i;
	byte Rcon[4] = { 0x01, 0x00, 0x00, 0x00 };		// 萔

	unsigned char BOOTFLASH * key = kTable;

	// g̐擪ɕ
	i = KEYLENGTH;
	do {
		*expandedKey = *key;
		expandedKey++;
		key++;
	} while( --i );

	// temp[]Ɍ̍ŏI4޲Ă
	expandedKey -= 4;
	temp[0] = *(expandedKey++);
	temp[1] = *(expandedKey++);
	temp[2] = *(expandedKey++);
	temp[3] = *(expandedKey++);

	// g
	i = KEYLENGTH;
	while( i < BLOCKSIZE*(ROUNDS+1) ) {
		// ̑傫̔{̎n߂ȂA
		if( (i % KEYLENGTH) == 0 ) {
			CycleLeft( temp );				// 1
			SubBytes( temp, 4 );			// e޲Ēu
			XORBytes( temp, Rcon, 4 );		// GF(2)Œ萔Z
			*Rcon = (*Rcon << 1) ^ (*Rcon & 0x80 ? BPOLY : 0);
		}

		// 24޲āA192ޯĂ傫Ȍ̑傫ŁA
		#if KEYLENGTH > 24
		// eʒŁA
		else if( (i % KEYLENGTH) == BLOCKSIZE ) {
			SubBytes( temp, 4 );			// e޲Ēu
		}
		#endif

		// KEYLENGTHGF(2)޲ĂZ
		XORBytes( temp, expandedKey - KEYLENGTH, 4 );

		// ʂ݂4޲Ăɕ
		*(expandedKey++) = temp[ 0 ];
		*(expandedKey++) = temp[ 1 ];
		*(expandedKey++) = temp[ 2 ];
		*(expandedKey++) = temp[ 3 ];

		i += 4;								// 4޲Ăֈʒuis
	}
}

void InvCipher( byte * block, byte * expandedKey )
{
	byte round = ROUNDS-1;
	expandedKey += BLOCKSIZE * ROUNDS;

	XORBytes( block, expandedKey, 16 );
	expandedKey -= BLOCKSIZE;

	do {
		InvShiftRows( block );
		InvSubBytesAndXOR( block, expandedKey, 16 );
		expandedKey -= BLOCKSIZE;
		InvMixColumns( block );
	} while( --round );

	InvShiftRows( block );
	InvSubBytesAndXOR( block, expandedKey, 16 );
}

void aesInit( unsigned char * tempbuf )
{
	powTbl = block1;
	logTbl = block2;
	CalcPowLog( powTbl, logTbl );

	sBox = tempbuf;
	CalcSBox( sBox );

	expandedKey = block1;
	KeyExpansion( expandedKey );
	
	sBoxInv = block2;				// block2łȂ΂Ȃ܂B
	CalcSBoxInv( sBox, sBoxInv );
}

void aesDecrypt( unsigned char * buffer, unsigned char * chainBlock )
{
	byte temp[ BLOCKSIZE ];

	CopyBytes( temp, buffer, BLOCKSIZE );
	InvCipher( buffer, expandedKey );
	XORBytes( buffer, chainBlock, BLOCKSIZE );
	CopyBytes( chainBlock, temp, BLOCKSIZE );
}

#endif
